// Generated by CoffeeScript 1.12.7
var FileTighter, _, exports, ficent, fs, glob, path, zlib;

_ = require('lodash');

glob = require('glob');

ficent = require('ficent').ficent;

path = require('path');

fs = require('fs');

zlib = require('zlib');


/*
  new FileTighter
    target: '*.log' or  ["*.log", '*.txt'] - glob pattern, single or array 
    fs_stats: false
    getDecision: (file_info)-> # 각 파일에 대하여 처리 방침을 결정    
      file_path = file_info.path
      fs_stats = file_info.stats
 */

FileTighter = (function() {
  function FileTighter(opt1) {
    this.opt = opt1;
    if (!Array.isArray(this.opt.target)) {
      this.opt.target = [this.opt.target];
    }
  }

  FileTighter.prototype.decidePolicy = function(file_info) {
    return "pass";
  };

  FileTighter.prototype.policy = {
    pass: function(file_info, done) {
      return done();
    },
    unlink: function(file_info, done) {
      return fs.unlink(file_info.path, done);
    },
    zip: function(file_info, done) {
      var gzip, inp, out;
      gzip = zlib.createGzip();
      inp = fs.createReadStream(file_info.path);
      out = fs.createWriteStream(file_info.path + '.zip');
      out.on('error', function(err) {
        return done();
      });
      out.on('finish', function() {
        return fs.unlink(file_info.path, function() {
          return done();
        });
      });
      return inp.pipe(gzip).pipe(out);
    }
  };

  FileTighter.prototype.doTight = function(callback) {
    var file_infos, opt, self;
    self = this;
    opt = this.opt;
    file_infos = null;
    return (ficent([
      function(_toss) {
        var args_list;
        args_list = _.map(opt.target, function(t) {
          return [
            t, {
              nodir: true
            }
          ];
        });
        return ficent.par(glob)(args_list, _toss.toItems('glob_results'));
      }, function(_toss) {
        var files, glob_results;
        glob_results = _toss.items().glob_results;
        files = _.uniq(_.flatten(glob_results));
        file_infos = _.map(files, function(f) {
          var status;
          return status = {
            path: f
          };
        });
        return _toss(null);
      }, function(_toss) {
        var _stat, args_list;
        if (!opt.fs_stats) {
          return _toss(null);
        }
        _stat = function(file_info, _toss) {
          return fs.stat(file_info.path, function(err, stats) {
            file_info.stats = stats;
            return _toss(null);
          });
        };
        args_list = _.map(file_infos, function(t) {
          return [t];
        });
        return ficent.ser(_stat)(args_list, _toss);
      }, function(_toss) {
        var _decision, args_list;
        _decision = function(file_info, _toss) {
          file_info.policy = self.decidePolicy(file_info);
          return _toss(null);
        };
        args_list = _.map(file_infos, function(t) {
          return [t];
        });
        return ficent.ser(_decision)(args_list, _toss);
      }, function(_toss) {
        var _do_policy, args_list;
        _do_policy = function(file_info, _toss) {
          return self.policy[file_info.policy](file_info, _toss);
        };
        args_list = _.map(file_infos, function(t) {
          return [t];
        });
        return ficent.ser(_do_policy)(args_list, _toss);
      }
    ]))(callback);
  };

  return FileTighter;

})();

module.exports = exports = FileTighter;
